package ftc;

import java.io.InputStream;
import java.io.OutputStream;
import java.nio.channels.ReadableByteChannel;
import java.nio.channels.WritableByteChannel;

public interface FTCClientVersionAdapter {
  void setBufferSize(int value) throws Exception;

  void open(boolean value) throws Exception;

  long getSize() throws Exception;

  void setSize(long value) throws Exception;

  long transferTo(long position, long length, OutputStream out)
    throws Exception;

  long transferTo(long position, long length, WritableByteChannel out)
    throws Exception;

  long transferFrom(InputStream in, long position, long length)
    throws Exception;

  long transferFrom(ReadableByteChannel in, long position, long length)
    throws Exception;

  void close() throws Exception;

  FTCVersion getVersion();
}
