package ftc.client;

import java.io.InputStream;
import java.io.OutputStream;
import java.nio.channels.ReadableByteChannel;
import java.nio.channels.WritableByteChannel;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;
import tecgraf.ftc_1_2.client.RemoteFileChannelImpl;
import ftc.FTCClientVersionAdapter;
import ftc.FTCVersion;

public class FTCClientV1_2 implements FTCClientVersionAdapter {

  RemoteFileChannelImpl rfc_impl = null;

  public FTCClientV1_2(String fileName, String host, int port, byte[] key) {
    rfc_impl =
      new RemoteFileChannelImpl(fileName.getBytes(), true, host, port, key);
  }

  @Override
  public void setBufferSize(int value) throws Exception {
    rfc_impl.setBufferSize(value);
  }

  @Override
  public void open(boolean value) throws Exception {
    rfc_impl.open(value);
  }

  @Override
  public long getSize() throws Exception {
    return rfc_impl.getSize();
  }

  @Override
  public void setSize(long value) throws Exception {
    rfc_impl.setSize(value);
  }

  @Override
  public long transferTo(long position, long length, OutputStream out)
    throws Exception {
    return rfc_impl.transferTo(position, length, out);
  }

  @Override
  public long transferFrom(InputStream in, long position, long length)
    throws Exception {
    return rfc_impl.transferFrom(in, position, length);
  }

  @Override
  public void close() throws Exception {
    rfc_impl.close();
  }

  @Override
  public FTCVersion getVersion() {
    return FTCVersion.FTC_V1_2;
  }

  @Override
  public long transferTo(long position, long length, WritableByteChannel out)
    throws Exception {
    throw new NotImplementedException();
  }

  @Override
  public long transferFrom(ReadableByteChannel in, long position, long length)
    throws Exception {
    throw new NotImplementedException();
  }

}
