package ftc.client;

import java.io.InputStream;
import java.io.OutputStream;
import java.nio.channels.ReadableByteChannel;
import java.nio.channels.WritableByteChannel;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;
import tecgraf.ftc_1_4.client.RemoteDataChannel;
import ftc.FTCClientVersionAdapter;
import ftc.FTCVersion;

public class FTCClientV1_4_0 implements FTCClientVersionAdapter {
  RemoteDataChannel rdc = null;

  public FTCClientV1_4_0(String fileName, String host, int port, byte[] key) {
    rdc = new RemoteDataChannel(true, host, port, key);
  }

  @Override
  public void setBufferSize(int value) throws Exception {
    rdc.setBufferSize(value);
  }

  @Override
  public void open(boolean value) throws Exception {
    rdc.open();
  }

  @Override
  public long getSize() throws Exception {
    return rdc.getSize();
  }

  @Override
  public void setSize(long value) throws Exception {
    rdc.setSize(value);
  }

  @Override
  public long transferTo(long position, long length, OutputStream out)
    throws Exception {
    throw new NotImplementedException();
  }

  @Override
  public long transferFrom(InputStream in, long position, long length)
    throws Exception {
    throw new NotImplementedException();
  }

  @Override
  public long transferTo(long position, long length, WritableByteChannel out)
    throws Exception {
    return rdc.transferTo(position, length, out);
  }

  @Override
  public long transferFrom(ReadableByteChannel in, long position, long length)
    throws Exception {
    return rdc.transferFrom(in, position, length);
  }

  @Override
  public void close() throws Exception {
    rdc.close();
  }

  @Override
  public FTCVersion getVersion() {
    return FTCVersion.FTC_V1_4_0;
  }

}
