
require("tableshow")
require("modules.m2mjava")
require("modules.m2mlua")
require("modules.m2mluacpp")

local m2mjava   = ftcbench.m2mjava
local m2mlua    = ftcbench.m2mlua
local m2mluacpp = ftcbench.m2mluacpp

module("ftcbench.clientbuffer",package.seeall)

local name = "FTC Client Buffer Size Module"

local conf 

function getName()
    return name
end

function setConfig(config)
    conf = config
end


function run()
    local M2M_SIZES = ftcbench.parameters.M2M_SIZES
    ftcbench.parameters.M2M_SIZES = {ftcbench.parameters.BUFFER_TEST_DATA_SIZE }
    for i=1,conf.RepeatTimes  do
        for _,size in ipairs(ftcbench.parameters.BUFFER_TEST_SIZES) do
            conf.BufferSize = size

            print( "Current Buffer Size: " .. size )

            print( "Starting tests with: " .. m2mjava.getName() )
            conf.LogFile = "buffer-java-" .. conf.ServerName .. ".txt"
            m2mjava.setConfig(conf)
            m2mjava.run()

            print( "Starting tests with: " .. m2mlua.getName() )
            conf.LogFile = "buffer-lua-" .. conf.ServerName .. ".txt"
            m2mlua.setConfig(conf)
            m2mlua.run()

            print( "Starting tests with: " .. m2mluacpp.getName() )
            conf.LogFile = "buffer-luaCpp-" .. conf.ServerName .. ".txt"
            m2mluacpp.setConfig(conf)
            m2mluacpp.run()
        end
    end
    ftcbench.parameters.M2M_SIZES = M2M_SIZES
end

