
local io = io
local print = print
local ipairs = ipairs
local pairs = pairs
local string = string
local PARAMS = ftcbench.parameters 

module("ftcbench.ftp")

local name = "FTP Client"

local command = "./bin/wget ftp://%s:%d/%s -O /dev/null  2>&1 | grep saved"

local conf 

function setConfig(config)
    conf = config
end

function transferFile(filename)
    local fullcmd =  string.format( command , conf.Hostname , conf.FTPServerPort or conf.Port , filename ) 
    if conf.Debug then
        print("Command: " .. fullcmd)
    end

    local output = io.popen(fullcmd)

    if not output then
        return nil , name .. " Error: Could not execute the given command!"
    end

    local outputFile , err  = io.open(conf.OutputDir .. "FTP-wget.txt", "a+")
    
    if not outputFile then
        return nil , name .. " Error: " .. err
    end
    outputFile:seek("end")
    outputFile:write(output:read("*all"))
    output:close()
    outputFile:close()
end

function getName()
    return name
end

function run()
    for i=1,conf.RepeatTimes  do
        for _,file in ipairs(conf.Files) do
            print( "Transfering file: " .. file )
            transferFile(file)
        end
    end
end
