#!/bin/sh

--LUA=`which lua5.1`

local io = io
local print = print
local ipairs = ipairs
local pairs = pairs
local PARAMS = ftcbench.parameters

module("ftcbench.lua")


local name = "FTC Lua Client"

local command = PARAMS.LUA_BIN .. " ./lua/src/perftest.lua "

local conf 

function setConfig(config)
    conf = config
end

function transferFile(filename)
    local logFile = conf.OutputDir .. "lua-" .. conf.ServerName .. ".txt"               
    if conf.LogFile ~= nil then
        logFile = conf.OutputDir .. conf.LogFile
    end

    local params = " -h " .. conf.Hostname .. 
                   " -p " .. conf.Port ..
                   " -b " .. conf.BufferSize ..  
                   " -l " .. logFile ..
                   " -c "

    if conf.FileSize > 0 then
        params = params ..  " -s " .. conf.FileSize .. " "
    end

    local fullcmd =  command .. params .. PARAMS.SERVER_FILES_DIR .. filename
    if conf.Debug then
        print("Command: " .. fullcmd)
    end

    local output = io.popen(fullcmd)

    if not output then
        return nil , name .. " Error: Could not execute the given command!"
    end

    output:close()
end

function getName()
    return name
end

function run()
    for i=1,conf.RepeatTimes  do
        for _,file in ipairs(conf.Files) do
            print( "Transfering file: " .. file )
            transferFile(file)
        end
    end
end
