local io = io
local print = print
local ipairs = ipairs
local pairs = pairs
local PARAMS = ftcbench.parameters

module("ftcbench.m2mlua")


local name = "FTC Lua Client"

local command = PARAMS.LUA_BIN .. " ./ftc-lua/perftest.lua "

local conf 

function setConfig(config)
    conf = config
end

function transferFile(filename,size)
    local logFile = conf.OutputDir .. "m2m-lua-" .. conf.ServerName .. ".txt"               
    if conf.LogFile ~= nil then
        logFile = conf.OutputDir .. conf.LogFile
    end

    local opts = " -h " .. conf.Hostname .. 
                 " -p " .. conf.Port ..
                 " -b " .. conf.BufferSize ..  
                 " -s " .. size .. 
                 " -l " .. logFile ..
                 " -c "

    local fullcmd =  command .. opts .. filename
    if conf.Debug then
        print("Command: " .. fullcmd)
    end

    local output = io.popen(fullcmd)

    if not output then
        return nil , name .. " Error: Could not execute the given command!"
    end

    output:close()
    return true
end

function getName()
    return name
end

function run()
    for i=1,#PARAMS.M2M_SIZES do
        local size = PARAMS.M2M_SIZES[i]
        for i=1,conf.RepeatTimes  do
            print( "Transfering "..size .." bytes from file: " .. PARAMS.MEM2MEM_FILE )
            local status,msg = transferFile( PARAMS.MEM2MEM_FILE , size )
            if not status then
                print(msg)
                break
            end
        end
    end
end
