
local io = io
local print = print
local ipairs = ipairs
local pairs = pairs
local setmetatable = setmetatable 
local os = os
local PARAMS = ftcbench.parameters 

module("ftcbench.multiclients")

local name = "Multiple FTC Clients"

local command = PARAMS.LUA_BIN .. ' ./ftcbench.lua -M java --singleclientlauch '

local conf 

function setConfig(config)
    conf = config
end

function getName()
    return name
end


function run()
    local cmd = command .. " -H " .. conf.Hostname
    print(cmd)
    if conf.Debug then print(cmd) end
    local hostname = os.getenv("HOST") or os.getenv("HOSTNAME") or "unknown"
    for i=1,conf.Clients do
        print("Starting FTC client number " .. i)
        io.popen( cmd .. " -n " .. conf.ServerName .. "-client" ..i .. "-" .. hostname .. " &")
    end
end

