#!/bin/bash

set -x
mkdir -p ./output/images
mkdir -p ./output/process
mkdir -p ./output/doc
cd graph

# Generate data base for all of the operation types.
IOZONE_FILE=../output/iozone.txt
./gengnuplot.sh $IOZONE_FILE write
./gengnuplot.sh $IOZONE_FILE rewrite
./gengnuplot.sh $IOZONE_FILE read
./gengnuplot.sh $IOZONE_FILE reread
./gengnuplot.sh $IOZONE_FILE randread
./gengnuplot.sh $IOZONE_FILE randwrite

lua5.1 wget-output.lua
lua5.1 processData.lua

# Produce graphs and postscript results.
gnuplot iozone.dem
gnuplot ftc-simple.dem
gnuplot ftc-m2m.dem
#gnuplot ftc-buffer.dem  
#gnuplot iperf.dem

lua5.1 gentex.lua

cd ../output/images

FILES=`ls *.eps`

for file in $FILES; do
	outfile=`echo $file|cut -d "." -f1`
	convert -antialias -density 200 -alpha off $file ${outfile}.png
done

